%define expat_version           1.95.5
%define glib2_version           2.2.0
%define dbus_version            0.20

%define lib_name %mklibname %{name} 0
%define lib_major 0

Summary: Hardware Abstraction Layer
Name: hal
Version: 0.4.7
Release: 11mdk
URL: http://www.freedesktop.org/Software/hal
Source0: http://freedesktop.org/~david/dist/%{name}-%{version}.tar.bz2
# (fc) 0.2.6-1mdk fix lock dir location and fix failed start
Patch0: hal-0.2.98-lockdir.patch.bz2
Patch2: hal-0.2.90-linux-headers.patch.bz2
# (fc) 0.2.97-3mdk fix start order (Mdk bug #11404)
Patch3: hal-0.2.97-order.patch.bz2
# (fc) 0.4.7-4mdk fix net link detection (Fedora)
Patch4: hal-0.4.7-fix-link-status.patch.bz2
# (fc) 0.4.7-4mdk default settings for mountpoints
Patch5: hal-0.4.7-defaults.patch.bz2
# (fc) 0.4.7-5mdk detect supermount entry in fstab (Mdk bug #13832)
Patch6: hal-0.4.7-supermount.patch.bz2
# (gb) 0.4.7-7mdk libtool fixes, don't bother with running aclocal, patch aclocal.m4 directly
Patch7: hal-0.4.7-lib64.patch.bz2
# (gb) 0.4.7-7mdk 64-bit fixes
Patch8: hal-0.4.7-64bit-fixes.patch.bz2
# (fc) 0.4.7-8mdk fix zip naming (CVS)
Patch9: hal-0.4.7-fixzip.patch.bz2
# (fc) 0.4.7-8mdk fix translation
Patch10: hal-0.4.7-fixpo.patch.bz2
# (fc) 0.4.7-9mdk fix media check on usb memory keys (Mdk bug #15070)
Patch11: hal-0.4.7-usbmediacheck.patch.bz2
# (fc) 0.4.7-9mdk fix huge memleak (CVS)
Patch12: hal-0.4.7-memleak.patch.bz2
License: AFL/GPL
Group: System/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
PreReq: rpm-helper
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: dbus-devel    >= %{dbus_version}
BuildRequires: libcap-devel
BuildRequires: libselinux-devel
BuildRequires: python python-devel
BuildRequires: pciutils
BuildRequires: popt-devel
BuildRequires: docbook-utils
BuildRequires: autoconf2.5 >= 2.58
BuildRequires: glibc-static-devel
BuildRequires: perl-XML-Parser
BuildRequires: ImageMagick
BuildRequires: docbook-dtd412-xml
BuildRequires: doxygen
Requires: dbus >= %{dbus_version}
#needed to get pci.ids
Requires: pciutils 
#needed to get usb.ids
Requires: usbutils

%description

HAL is daemon for collection and maintaining information from several
sources about the hardware on the system. It provdes a live device
list through D-BUS.


%package gnome
Summary: GNOME based device manager for HAL
Group: Graphical desktop/GNOME
Requires: dbus-python >= %{dbus_version}
Requires: pygtk2.0-libglade >= 2.0.0
Requires: gnome-python >= 2.0.0

%description gnome
GNOME program for displaying the devices detected by HAL

%package -n %{lib_name}
Summary: Shared library for using HAL
Group: System/Libraries
Requires: %name >= %{version}-%{release}

%description -n %{lib_name}
HAL shared library.

%package -n %{lib_name}-devel
Summary: Libraries and headers for HAL
Group: Development/C
Requires: %{name} = %{version}-%{release}
Requires: %{lib_name} = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: lib%{name}-devel = %{version}-%{release}
#gw got this from the pkgconfig file:
Requires: dbus-devel >= %{dbus_version}

%description -n %{lib_name}-devel

Headers and static libraries for HAL.


%prep
%setup -q
%patch0 -p1 -b .lockdir
%patch2 -p1 -b .header
%patch3 -p1 -b .order
%patch4 -p1 -b .fix-link-status
%patch5 -p1 -b .defaults
%patch6 -p1 -b .supermount
%patch7 -p1 -b .libtool
%patch8 -p1 -b .64bit-fixes
%patch9 -p1 -b .fixzip
%patch10 -p1 -b .fixpo
%patch11 -p1 -b .usbmediacheck
%patch12 -p1 -b .memleak
autoconf

%build

%configure2_5x --with-pid-file=%{_var}/run/haldaemon.pid --enable-fstab-sync --enable-hotplug-map  --enable-pcmcia-support --enable-sysfs-carrier

%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

%find_lang %{name}

cat << EOF > $RPM_BUILD_ROOT%{_datadir}/hal/fdi/30osvendor/usb-disable-mediacheck.fdi
<?xml version="1.0" encoding="ISO-8859-1"?> <!-- -*- SGML -*- -->

<deviceinfo version="0.2">
  <device>
    <match key="info.bus" string="usb">
      <match key="usb.vendor_id" int="0x67b">
        <match key="usb.product_id" int="0x2317">
          <merge key="storage.media_detection_enabled" type="bool">false</merge>
        </match>
      </match>
    </match>
  </device>
</deviceinfo>
EOF

install -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/hal-gnome <<EOF
?package(hal-gnome): \
	command="%{_bindir}/hal-device-manager" \
	needs="X11" \
	section="Configuration/Hardware" \
	icon="hal-device-manager.png" \
	title="Device Manager" \
	longtitle="Shows information about hardware on your system" \
	startup_notify="true"
EOF
mkdir -p %buildroot{%_liconsdir,%_miconsdir,%_iconsdir}
convert -scale 48x48 tools/device-manager/fdo-logo.png %buildroot%_liconsdir/hal-device-manager.png
convert -scale 32x32 tools/device-manager/fdo-logo.png %buildroot%_iconsdir/hal-device-manager.png
convert -scale 16x16 tools/device-manager/fdo-logo.png %buildroot%_miconsdir/hal-device-manager.png

# remove sony DSC file, it confuses HAL and gvm to much
rm -f $RPM_BUILD_ROOT%{_datadir}/hal/fdi/20freedesktop/sony_dsc.fdi

%clean
rm -rf %{buildroot}

%triggerpostun -- hal < 0.2.97-3mdk
/sbin/chkconfig --del haldaemon
/sbin/chkconfig --add haldaemon


%pre
%_pre_useradd haldaemon / /sbin/nologin
%_pre_groupadd daemon hamdaemon

%post -n %{lib_name} -p /sbin/ldconfig

%post
%_post_service haldaemon

%preun
%_preun_service haldaemon

%postun -n %{lib_name} -p /sbin/ldconfig

%postun
%_post_service haldaemon

%post gnome
%update_menus

%postun gnome
%clean_menus

%files -f %{name}.lang
%defattr(-,root,root)
%doc COPYING ChangeLog NEWS
%doc doc/conf/*.fdi
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/hal.conf
%config(noreplace) %{_sysconfdir}/rc.d/init.d/*
%config(noreplace) %{_sysconfdir}/dev.d/default/10-hal.dev
%config(noreplace) %{_sysconfdir}/hal/device.d/40-hal-hotplug-map.hal
%config(noreplace) %{_sysconfdir}/hal/device.d/50-fstab-sync.hal
%config(noreplace) %{_sysconfdir}/hal/hald.conf
%dir %{_sysconfdir}/hal/
%dir %{_sysconfdir}/hal/device.d
%{_sbindir}/hald
%{_sbindir}/fstab-sync
%{_bindir}/lshal
%{_bindir}/hal-get-property
%{_bindir}/hal-set-property
%_mandir/man8/fstab-sync.8*

%{_libexecdir}/hal.hotplug
%{_libexecdir}/hal.dev
%{_libexecdir}/hal-hotplug-map
%{_sysconfdir}/hotplug.d/default/20-hal.hotplug

%dir %{_datadir}/hal
%{_datadir}/hal/fdi

%files -n %{lib_name}
%defattr(-,root,root)
%{_libdir}/*hal*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc doc/api/html/ doc/TODO doc/spec/*.png doc/spec/*.html
%{_libdir}/lib*.a
%{_libdir}/lib*.la
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*


%files gnome
%defattr(-,root,root)
%{_datadir}/hal/device-manager
%{_bindir}/hal-device-manager
%_menudir/hal-gnome
%_liconsdir/hal-device-manager.png
%_iconsdir/hal-device-manager.png
%_miconsdir/hal-device-manager.png

%changelog
* Wed Apr 06 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-11mdk 
- Update patch1& to only disable media check for blaclisted devices

* Mon Apr 04 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-10mdk 
- Remove Sony DSC fdi file, it confuses HAL and g-v-m

* Thu Mar 31 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-9mdk 
- Patch11: disable media check after first check for USB memory key (Mdk bug #15070)
- Update patch5 to enable back media check 
- Patch12 (CVS): fix huge memleak

* Thu Mar 17 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-8mdk 
- Patch9 (CVS): fix zip naming
- Patch10 (CVS): fix translation

* Tue Mar  8 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.7-7mdk
- libtool & 64-bit fixes

* Thu Feb 24 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-6mdk 
- Update patch0 to better detect when startup failed (Mdk bug #13949)

* Mon Feb 21 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-5mdk 
- Patch6: detect supermount entry in fstab (Mdk bug #13832)

* Tue Feb 15 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-4mdk 
- Patch4 (Fedora): fix net link status detection
- Patch5: change defaults settings (based on patch from Fabrice Facorat)
- Requires usbutils to get usb.ids
- Enable sysfs carrier and pcmcia support

* Fri Feb 11 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.4.7-3mdk
- add BuildRequires: docbook-dtd412-xml doxygen

* Sat Feb  5 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.4.7-2mdk
- fix buildrequires

* Thu Jan 27 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.4.7-1mdk
- add more docs
- New release 0.4.7

* Thu Jan 20 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.4.5-1mdk
- update file list
- New release 0.4.5

* Fri Dec 10 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.2-1mdk
- New release 0.4.2

* Thu Dec 09 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.1-3mdk
- library package now requires main package

* Thu Nov 11 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.1-2mdk
- build with libselinux

* Wed Nov 10 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.1-1mdk
- drop merged patches 4,5
- New release 0.4.1

* Fri Nov  5 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.0-2mdk
- buildrequires

* Mon Oct 18 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.0-1mdk
- Release 0.4.0
- Patch4 (Fedora): fix NON_BLOCK usage
- Patch5 (Fedora): don't use UUID as mount point name

* Fri Sep 24 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.98-2mdk
- fix buildrequires

* Thu Sep 23 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.98-1mdk
- adapt file list
- drop merged patch 1
- rediff patch 0
- New release 0.2.98

* Mon Sep 13 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.97-3mdk
- Patch3 : Start haldaemon earlier in boot process (Mdk bug #11404)

* Mon Sep 13 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.97-2mdk
- fix buildrequires

* Fri Sep 10 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.97-1mdk
- Release 0.2.97
- Remove patch 3 (merged upstream)

* Fri Jul 16 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.94-1mdk
- update file list
- fix build
- New release 0.2.94

* Fri Jul  9 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.93-1mdk
- add configuration file
- fix URL
- reenable libtooize
- patch2 to fix build
- new version

* Thu Apr 22 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.90-3mdk
- remove device manager from main package
- add menu entry for the hal-device-manager

* Wed Apr 21 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.90-2mdk
- fix buildrequires

* Tue Apr 20 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.90-1mdk
- Release 0.2.90 (grabbed from project Utopia)
- Requires pciutils to get pci.ids file 

* Sat Jan 31 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.6-5mdk
- fix buildrequires

* Sat Jan 31 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.6-4mdk
- fix devel requires

* Fri Jan 30 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.6-3mdk
- fix buildrequires

* Thu Jan 29 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.6-2mdk
- Fix hal-gnome dependency (houpla)

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.6-1mdk
- First Mandrake package  (based on David Zeuthen package)
- Patch0 : fix lock directory location

